#include "jserver.h"

void js_bounce(xmlnode x, terror terr)
{
    if(j_strcmp(xmlnode_get_name(x),"presence") == 0 && j_strcmp(xmlnode_get_attrib(x,"type"),"subscribe") == 0)
    { /* bounce subscriptions only */
        jutil_iqresult(x); /* hack alert, but it get's the job done */
        xmlnode_put_attrib(x,"type","unsubscribed");
        xmlnode_insert_cdata(xmlnode_insert_tag(x,"status"),terr.msg,-1);
        js_deliver(jpacket_new(x));
        return;
    }

    if(j_strcmp(xmlnode_get_name(x),"presence") == 0 || j_strcmp(xmlnode_get_attrib(x,"type"),"error") == 0)
    { /* presence packets are just dropped */
        log_debug(ZONE,"dropping %d packet %s",terr.code,xmlnode2str(x));
        xmlnode_free(x);
        return;
    }

    jutil_error(x, terr);
    js_deliver(jpacket_new(x));
}

